<template>
  <div class="flex flex-col w-full">
    <label
      class="
    bg-white border border-grey-darker rounded-lg relative
    px-5 pt-8 pb-3 w-full input-wrapper focus-within:border-black
"
      :class="{error: errorMessage}"
    >
      <input
        :type="type"
        :value="value"
        @input="$emit('input', $event.target.value)"
        :placeholder="placeholder"
        class="
      appearance-none outline-none bg-transparent
      text-black text-base placeholder-grey-dark
"
      >
      <span
        v-if="label"
        class="
      absolute text-base text-grey-dark left-5 transition-all label
"
        :class="[{'label-on-top': isLabelOnTop}, placeholder ? 'top-8' : 'top-1/2 transform -translate-y-1/2']"
      >
      {{ label }}
    </span>
    </label>
    <span
      v-if="errorMessage"
      class="input-error-msg"
    >
      {{errorMessage}}
    </span>
  </div>
</template>

<script>
export default {
  name: "TextInput",
  props: {
    placeholder: String,
    value: String,
    label: {
      type: String,
      required: true
    },
    errorMessage: String,
    type: {
      type: String,
      default: 'text',
      validator(value) {
        return ['text', 'password', 'email'].includes(value)
      }
    }
  },
  computed: {
    isLabelOnTop() {
      return this.placeholder || this.value
    }
  }
}
</script>

<style scoped>
input:focus + span, .label-on-top {
  @apply text-xs top-2 translate-y-0;
}

.input-wrapper.error {
  @apply bg-red-light bg-opacity-5 border-red-light;
}

.input-wrapper.error .label {
  @apply text-red-light
}

</style>
